1
0
Files
TP-Link_XR500v_v2-6/automake-1.11/tests/check4-p.test
2016-11-30 09:03:17 +08:00

85 lines
2.1 KiB
Bash
Executable File

#! /bin/sh
# Copyright (C) 2005, 2007, 2008 Free Software Foundation, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
# Make sure `make -k check' processes all directories.
. ./defs-p || Exit 1
set -e
cat >> configure.in << 'END'
AC_CONFIG_FILES([dir/Makefile])
AC_OUTPUT
END
mkdir dir
cat > Makefile.am <<'END'
SUBDIRS = dir
TESTS = ok.sh
END
echo TESTS = fail.sh >dir/Makefile.am
cat >ok.sh <<'END'
#!/bin/sh
:
END
cat >dir/fail.sh <<'END'
#!/bin/sh
exit 1
END
chmod +x ok.sh dir/fail.sh
$ACLOCAL
$AUTOCONF
$AUTOMAKE
./configure --prefix "`pwd`/inst"
$MAKE check >stdout && { cat stdout; Exit 1; }
cat stdout
grep 'FAIL: fail.sh' stdout
grep 'PASS: ok.sh' stdout && Exit 1
# The exit status of `make -k' can be anything
# (depending on the Make implementation)
$MAKE -k check >stdout || :
cat stdout
grep 'FAIL: fail.sh' stdout
grep 'PASS: ok.sh' stdout
# should also works when -k is not in first position
$MAKE -s -k check >stdout || :
cat stdout
grep 'FAIL: fail.sh' stdout
grep 'PASS: ok.sh' stdout
# The rest of the test is for GNU Make.
# Use --version AND -v, because SGI Make doesn't fail on --version.
# Also grep for GNU because newer versions of FreeBSD make do
# not complain about `--version' (they seem to silently ignore it).
($MAKE --version -v | grep GNU) || Exit 0
# Try with a long-option that do not have a short option equivalent
# (here, --no-print-directory). That should cause all options to
# appear verbatim in MAKEFLAGS.
$MAKE --no-print-directory -k check >stdout || :
cat stdout
grep 'FAIL: fail.sh' stdout
grep 'PASS: ok.sh' stdout